/////////////////////////////////////////////////
//              eGizmo OBSTAPROX BOT           //
//                                             //
// This enables a bot to avoid obstacles and   //
// may also solve mazes. The program does not  //
// include the use of the line sensor and is   //
// optional. The codes for the line sensors    //
// are included just in case it is needed.     //
//                                             //
// Codes by:                                   //
// e-Gizmo Mechatronix Central                 //
// Taft, Manila, Philippines                   //
// http://www.egizmo.com                       //
// July 6, 2013                                //
/////////////////////////////////////////////////

// Connections:
#define infrared 12 // Infrared sensor
#define line1 5    // Line sensor  //
#define line2 6    // Line sensor  // These are optional
#define line3 7    // Line sensor  //

#define motor1 8   // Motor control HIGH = FWD, LOW = BWD
#define motor2 9   // Speed input
#define motor3 10  // Speed input
#define motor4 11  // Motor control HIGH = FWD, LOW = BWD

int safespeed = 250;              // Neutral speed
int timer = 0;
int stucktimer = 0;
int rotate;

int z = 0;
int y = 0;


void setup() 
{                
  Serial.begin(9600);

  pinMode(motor1, OUTPUT);       // Set all motor driver pins to output
  pinMode(motor2, OUTPUT);
  pinMode(motor3, OUTPUT);
  pinMode(motor4, OUTPUT);

  pinMode(infrared, INPUT);

  pinMode(line1, INPUT);         // All line sensor pins should be set as input
  pinMode(line2, INPUT);
  pinMode(line3, INPUT);
}

void loop()  {

  int infraSense = digitalRead(infrared);

  ////////////////// MOBOT Functions ///////////////////////

  if(infraSense == 1)
  {
    FORWARD();
  }


  // If the bot is about to hit the wall, turn right
  if((z == 0 && infraSense == 0) && y == 0)
  {
    z = 1;
  }

  if(z == 1  && timer <= 10)
  {

    LEFT_TURN();
    timer++;
    stucktimer++;
    delay(80);

    if(timer == 10)
    {
      timer = 20;
      y = 1;
      z = 2;
    }
  }
  
  // If right is not the way, turn left
  if(infraSense == 0 && y == 1)
  {
    y = 2;
  }
    
  if(y == 2 && timer >= 20)
  {
    RIGHT_TURN();
    timer++;
        stucktimer++;
    delay(80);
    
    if(timer == 30)
    {
      timer = 0;
      y = 0;
      z = 0;
    }
  }
  
  // If bot is stuck,
  if(stucktimer >= 100)
  {
    stucktimer = 0;
    ROTATE();
    delay(800);
  }
    


}

// PRESET FUNCTIONS:

void FORWARD()
{    
  digitalWrite(motor1, HIGH);
  digitalWrite(motor4, HIGH);

  analogWrite(motor2, safespeed);    
  analogWrite(motor3, safespeed);    
}

void BACKWARD()
{    
  digitalWrite(motor1, LOW);
  digitalWrite(motor4, LOW);

  analogWrite(motor2, safespeed);    
  analogWrite(motor3, safespeed);    
}



void ROTATE()    // Default reaction after timer runs out
{
  digitalWrite(motor1,LOW);
  digitalWrite(motor4,HIGH);
  digitalWrite(motor2,HIGH);
  digitalWrite(motor3,HIGH);
}


void STOP()
{
  digitalWrite(motor1,HIGH);
  digitalWrite(motor4,HIGH);

  analogWrite(motor2,1);
  analogWrite(motor3,1);
  delay(10);
}


void LEFT_TURN()
{     
  digitalWrite(motor1,HIGH);
  digitalWrite(motor4,HIGH);

  analogWrite(motor2,10);
  analogWrite(motor3,250);
}

void RIGHT_TURN()
{
  digitalWrite(motor1,HIGH);
  digitalWrite(motor4,HIGH);

  analogWrite(motor2,250);
  analogWrite(motor3,10);
}





